"""
OD generate constants
"""

import pycityproto.city.geo.v2.geo_pb2 as geov2
import pycityproto.city.map.v2.map_pb2 as mapv2
import pycityproto.city.person.v2.person_pb2 as personv2
import pycityproto.city.trip.v2.trip_pb2 as tripv2

DIS_CAR = 1000
DIS_BIKE = 500
V_CAR = 20 / 3.6
V_BIKE = 10 / 3.6
HUMAN_MODE_STATS = {
    "HWH": 18.79,
    "HWH+": 20.03,
    "HW+WH": 13.76,
    "HWHWH": 1.09,
    "HSH": 3.1,
    "HSH+": 3.36,
    "HOH": 10.91,
    "HOH+": 11.45,
    "HWHWH+": 1.43,
    "HSOSH": 0.00,
}
BUS = tripv2.TRIP_MODE_BUS_WALK
CAR = tripv2.TRIP_MODE_DRIVE_ONLY
BIKE = tripv2.TRIP_MODE_BIKE_WALK
WALK = tripv2.TRIP_MODE_WALK_ONLY
LANE_TYPE_DRIVING = mapv2.LANE_TYPE_DRIVING
ALL_TRIP_MODES = [
    BUS,
    BUS,
    CAR,
    CAR,
    WALK,
]
PT_START_ID = 1_0000_0000
PRIMARY_SCHOOL, JUNIOR_HIGH_SCHOOL, HIGH_SCHOOL, COLLEGE, BACHELOR, MASTER, DOCTOR = (
    personv2.EDUCATION_PRIMARY_SCHOOL,
    personv2.EDUCATION_JUNIOR_HIGH_SCHOOL,
    personv2.EDUCATION_HIGH_SCHOOL,
    personv2.EDUCATION_COLLEGE,
    personv2.EDUCATION_BACHELOR,
    personv2.EDUCATION_MASTER,
    personv2.EDUCATION_DOCTOR,
)
EDUCATION_LEVELS = [
    PRIMARY_SCHOOL,
    JUNIOR_HIGH_SCHOOL,
    HIGH_SCHOOL,
    COLLEGE,
    BACHELOR,
    MASTER,
    DOCTOR,
]
# probabilities
EDUCATION_STATS = [1 / len(EDUCATION_LEVELS) for _ in range(len(EDUCATION_LEVELS))]
CONSUMPTION_LEVELS = [
    personv2.CONSUMPTION_LOW,
    personv2.CONSUMPTION_RELATIVELY_LOW,
    personv2.CONSUMPTION_MEDIUM,
    personv2.CONSUMPTION_RELATIVELY_HIGH,
    personv2.CONSUMPTION_HIGH,
]
# probabilities
CONSUMPTION_STATS = [
    1 / len(CONSUMPTION_LEVELS) for _ in range(len(CONSUMPTION_LEVELS))
]
GENDERS = [
    personv2.GENDER_FEMALE,
    personv2.GENDER_MALE,
]
# probabilities
GENDER_STATS = [1 / len(GENDERS) for _ in range(len(GENDERS))]
AGES = [i for i in range(8, 75)]
# probabilities
AGE_STATS = [1 / len(AGES) for _ in range(len(AGES))]
# work catg
WORK_CATGS = {"business", "industrial", "administrative"}
# education catg
EDUCATION_CATGS = {"education"}
# home catg
HOME_CATGS = {"residential"}
PT_DRIVER_ATTRIBUTES = {
    "BUS": {
        "length": 15,
        "width": 2,
        "max_speed": 41.666666666666664,
        "max_acceleration": 3,
        "max_braking_acceleration": -10,
        "usual_acceleration": 2,
        "usual_braking_acceleration": -4.5,
        "headway": 1.5,
        "lane_max_speed_recognition_deviation": 1.0,
        "lane_change_length": 10,
        "min_gap": 1,
        "emission_attribute": {
            "weight": 18000,
            "type": personv2.VehicleEngineType.VEHICLE_ENGINE_TYPE_FUEL,
            "coefficient_drag": 0.251,
            "lambda_s": 0.29,
            "frontal_area": 8.67,
            "fuel_efficiency": {"energy_conversion_efficiency": 0.27 * 0.049},
        },
    },
    "SUBWAY": {
        "length": 25,
        "width": 2,
        "max_speed": 41.666666666666664,
        "max_acceleration": 3,
        "max_braking_acceleration": -10,
        "usual_acceleration": 2,
        "usual_braking_acceleration": -4.5,
        "headway": 1.5,
        "lane_max_speed_recognition_deviation": 1.0,
        "lane_change_length": 10,
        "min_gap": 1,
        "emission_attribute": {
            "weight": 18000,
            "type": personv2.VehicleEngineType.VEHICLE_ENGINE_TYPE_FUEL,
            "coefficient_drag": 0.251,
            "lambda_s": 0.29,
            "frontal_area": 8.67,
            "fuel_efficiency": {"energy_conversion_efficiency": 0.27 * 0.049},
        },
    },
    "UNSPECIFIED": {
        "length": 5,
        "width": 2,
        "max_speed": 41.666666666666664,
        "max_acceleration": 3,
        "max_braking_acceleration": -10,
        "usual_acceleration": 2,
        "usual_braking_acceleration": -4.5,
        "headway": 1.5,
        "lane_max_speed_recognition_deviation": 1.0,
        "lane_change_length": 10,
        "min_gap": 1,
        "emission_attribute": {
            "weight": 2100,
            "type": personv2.VehicleEngineType.VEHICLE_ENGINE_TYPE_FUEL,
            "coefficient_drag": 0.251,
            "lambda_s": 0.29,
            "frontal_area": 2.52,
            "fuel_efficiency": {"energy_conversion_efficiency": 0.27 * 0.049},
        },
    },
}
MAX_ACC_PDF_DICT = {
    "human": [
        0.013941517103511023,
        0.020000714966780662,
        0.02446914993393108,
        0.044291127450010855,
        0.05510474014153518,
        0.06246872098980547,
        0.06765210550968795,
        0.07154858085465843,
        0.072013298066435,
        0.06942160575647946,
        0.06493529707926896,
        0.059448058888193545,
        0.053746335876311384,
        0.04811610780469813,
        0.04237863732268152,
        0.03589046971776978,
        0.030724958907947388,
        0.026542503751886933,
        0.02205619502466213,
        0.01874955316197454,
        0.015228426378451603,
        0.012297133047202986,
        0.012154143116650855,
        0.009312218490746964,
        0.007703581899571955,
        0.006684778725661259,
        0.005844712947435722,
        0.005111889609622139,
        0.003628369198927742,
        0.003556874238653106,
        0.003217273182350018,
        0.0024129548842617985,
        0.0020733538279587094,
        0.0019303639124108685,
        0.0015192678908317145,
        0.0010366769154797838,
        0.0009115607359994576,
        0.0007506970758816708,
        0.0005004647169210186,
        0.00041109601807815313,
        0.0002144848786732916,
    ],
    "auto": [
        0.0011860203893293859,
        0.002354585955154446,
        0.0043949850751181805,
        0.007530821031249468,
        0.010694040113165692,
        0.01361476279639748,
        0.019531948209746734,
        0.023895654232354565,
        0.04325305415040121,
        0.05381322279446794,
        0.06100461034160689,
        0.06606650928680462,
        0.06987166099087735,
        0.07032548639300291,
        0.06779453687156195,
        0.06341337605397357,
        0.05805474500800149,
        0.05248665612921032,
        0.04698838652802551,
        0.04138538801043116,
        0.035049286833759546,
        0.030004842683542362,
        0.025920413820202076,
        0.021539252953771605,
        0.018310110509740758,
        0.01487151013520664,
        0.012008918991409163,
        0.011869280387354348,
        0.00909396336987008,
        0.007523029198800736,
        0.006528104224278572,
        0.005707727487730196,
        0.0049920796968966185,
        0.003543329295827872,
        0.003473509998684673,
        0.003141868342138689,
        0.002356401254161912,
        0.0020247595976159265,
        0.0018851210082137383,
        0.0014836600496403458,
        0.001012379800273226,
    ],
}
HEADWAY_PDF_DICT = {
    "human": [
        0.11953227764297882,
        0.18502092093826158,
        0.18519191637708438,
        0.1633496404396733,
        0.09571688185255992,
        0.04796465382704443,
        0.03797995895331154,
        0.03150869480393995,
        0.02528938981976895,
        0.021159588492459105,
        0.017260169233779227,
        0.014470700453813237,
        0.01240683168297191,
        0.01007789942803244,
        0.009003639816491903,
        0.0070901712664767965,
        0.006725531373957196,
        0.005107411799312519,
        0.005143721798082854,
    ],
    "auto": [
        0.018901528489611314,
        0.026261145840457294,
        0.037671101700393735,
        0.05202283151755771,
        0.09069678469549351,
        0.14940656077182174,
        0.13882991936297465,
        0.10683515385818013,
        0.08598417345842699,
        0.06681809602058035,
        0.054008495971711194,
        0.04245239620043045,
        0.0341977757332246,
        0.02807899401190717,
        0.021758712354093095,
        0.018461437382809195,
        0.013732957137195278,
        0.008645916712487071,
        0.005236018780644792,
    ],
}
BRAKE_ACC_PDF_DICT = {
    "human": [
        0.00031900342432624254,
        0.00048795710619575446,
        0.0005391938195280784,
        0.0006489836151576824,
        0.0007471858403394611,
        0.0008508764487738386,
        0.0010173913409883652,
        0.0011857386450307755,
        0.0014474061688294674,
        0.0017127340901684008,
        0.0021232253224230412,
        0.002737441800121722,
        0.0033303155487526357,
        0.004178142403928861,
        0.005271167207030457,
        0.006645378703401679,
        0.008244056222573133,
        0.01007450728127872,
        0.01258199910146314,
        0.015729330182127927,
        0.019265805339864064,
        0.023373191860989666,
        0.028630939085744413,
        0.034590739050817054,
        0.04060238210704911,
        0.04729960832772574,
        0.0543792730604514,
        0.060519003473898735,
        0.06668862344549513,
        0.07172069631791096,
        0.0755115182043653,
        0.07874545951364852,
        0.0807198611276156,
        0.0770052790811016,
        0.07966770264916824,
        0.08140788308171518,
    ],
    "auto": [
        0.0004057505223929082,
        0.0004512429130422547,
        0.0005618552083941799,
        0.0006487509860848373,
        0.0007532297760247087,
        0.0008767233229459257,
        0.0010237301242866474,
        0.0012236921929633705,
        0.0014567772680078015,
        0.0017710311418143634,
        0.002203462561117036,
        0.002745690255457984,
        0.003434516740982828,
        0.004283844036489573,
        0.0053950826955387636,
        0.006758013176456907,
        0.008368135498132543,
        0.010358143465604975,
        0.012867273883155674,
        0.015948278754878885,
        0.019565582562446046,
        0.02389031663501598,
        0.029027370740031973,
        0.034802748575197655,
        0.041060652574884345,
        0.04769394520660295,
        0.05437017385987925,
        0.06086954420506821,
        0.06668254354403974,
        0.07170816784971687,
        0.07507930876176247,
        0.0770902821723903,
        0.07792621300187315,
        0.07890577489612442,
        0.07960569842943174,
        0.08018645246176276,
    ],
}
MAX_ACC_VALUES = [
    1.0,
    1.1,
    1.2,
    1.3,
    1.4,
    1.5,
    1.6,
    1.7,
    1.8,
    1.9,
    2.0,
    2.1,
    2.2,
    2.3,
    2.4,
    2.5,
    2.6,
    2.7,
    2.8,
    2.9,
    3.0,
    3.1,
    3.2,
    3.3,
    3.4,
    3.5,
    3.6,
    3.7,
    3.8,
    3.9,
    4.0,
    4.1,
    4.2,
    4.3,
    4.4,
    4.5,
    4.6,
    4.7,
    4.8,
    4.9,
    5.0,
]
HEADWAY_VALUES = [
    1.0,
    1.5,
    2.0,
    2.5,
    3.0,
    3.5,
    4.0,
    4.5,
    5.0,
    5.5,
    6.0,
    6.5,
    7.0,
    7.5,
    8.0,
    8.5,
    9.0,
    9.5,
    10.0,
]
BRAKE_ACC_VALUES = [
    -4.0,
    -3.9,
    -3.8,
    -3.7,
    -3.6,
    -3.5,
    -3.4,
    -3.3,
    -3.2,
    -3.1,
    -3.0,
    -2.9,
    -2.8,
    -2.7,
    -2.6,
    -2.5,
    -2.4,
    -2.3,
    -2.2,
    -2.1,
    -2.0,
    -1.9,
    -1.8,
    -1.7,
    -1.6,
    -1.5,
    -1.4,
    -1.3,
    -1.2,
    -1.1,
    -1.0,
    -0.9,
    -0.8,
    -0.7,
    -0.6,
    -0.5,
]
